public class PrintQueueManager {

  PriorityQueue queue;

  /**
   * Initialize the manager, empty.
   */
  public PrintQueueManager() {
    queue = new BinaryHeap();
  }

  /**
   * Adds a new work to print, with the indicated priority. *
   */
  public void print(int priority, String file) {
    queue.insert(priority, file);
  }

  /**
   * Processes (prints out of the printer) the first work of the queue, with the
   * highest priority, reorganizing the data structure.
   */
  public void process() {
    queue.extract();
  }
}
