interface PriorityQueue {

  static int MAX_PRIORITY = 1;

  /**
   * Insert the indicated object in the correct position in the queue, depending
   * on its priority. Priority is declared with a natural number (> 0). The
   * bigger is this number, the lower is the element priority associated with
   * the number. The value 1 corresponds to elements with maximum priority.
   */
  void insert(int priority, Object info);

  /**
   * Extract the object with highest priority out of the queue (that is, the one
   * with the minimum priority) In case that several elements have the same high
   * priority, the first introduced (FIFO) will be returned. If queue is empty,
   * null is returned.
   */
  Object extract();

  /**
   * Returns the number of elements in the queue.
   */
  int size();

  /**
   * Indicates if the queue is empty.
   */
  boolean isEmpty();

}
